// 
// Glow Hott pour télémesure Graupner Hott
// 
// Filtrage pour valeur compte-tours
//
// Auteur : www.thyzoon.fr 
// 2015

#include "Arduino.h"

// Filtre pour compte-tours moteur
// Filtrage median = : tri de 3 valeurs, pris en compte de la valeur mediane.
// Moyenne de 8 valeurs consécutives.
//
word median (word v) {
 
  byte i,j;
  word mini; 
  word temp;
  
  static word t0=0,t1=0,t2=0;       // Variables de memorisation car le tableau ne peut pas etre static
  word t[3];                        // tableau utilise pour le tri des valeurs
  static long fi0=0,fi1=0,fi2=0,fi3=0,fi4=0,fi5=0,fi6=0,fi7=0;   // variables du filtre
  long filtre;                // resultat du filtrage
  
  // Decalage des 3 echantillons (2 memorisées et nouvelle valeur)
  t2 = t1;
  t1 = t0;
  t0 = v;
  
  // Transfert des 3 valeurs dans le tableau pour faire le tri
  t[0] = t0;
  t[1] = t1;
  t[2] = t2;
  
  // Tri des valeurs par ordre croissant 
  for (i=0; i<=1; i++) {
    mini = i;
    for (j=i+1; j<=2; j++) {
      if (t [j] < t [mini])
        mini = j;        
    }
    if (mini != i) { // échange
      temp = t [i];
      t [i] = t [mini];
      t [mini] = temp;
    }  
  }
  
  // Valeur médiane => t[1]
  fi0 = (long) t[1];
  // Moyenne des 8 dernieres valeurs
  filtre = (fi0 + fi1 + fi2 + fi3 + fi4 + fi5 + fi6 + fi7)/8;
  fi7 = fi6;  // Décalage   
  fi6 = fi5;  // Décalage 
  fi5 = fi4;  // Décalage   
  fi4 = fi3;  // Décalage   
  fi3 = fi2;  // Décalage 
  fi2 = fi1;  // Décalage 
  fi1 = fi0;  // mémorisation valeur mediane
  
  return ((word)filtre); 
}

